/*
This program has been developed by students from the bachelor Computer Science at Utrecht University within the Software Project course.
© Copyright Utrecht University (Department of Information and Computing Sciences)
*/

package main

import (
	"encoding/json"
	"log"

	"git.science.uu.nl/graphpolaris/query-conversion/aql"
	"git.science.uu.nl/graphpolaris/query-conversion/entity"
)

/*
The main function that calls the appropriate functions
*/
func main() {
	queryservice := aql.NewService()

	js := []byte(`{
    "return": {
        "entities": [
            0,
            1
        ],
        "relations": [
            0
        ]
    },
    "entities": [
        {
            "type": "parliament",
            "constraints": []
        },
        {
            "type": "commissions",
            "constraints": []
        }
    ],
    "relations": [
        {
            "type": "part_of",
            "depth": {
                "min": 1,
                "max": 1
            },
            "entityFrom": 0,
            "entityTo": 1,
            "constraints": [],
            "functionPointer": {
                "from": -1,
                "to": -1
            }
   
        }
    ],
    "functions": [
        {
            "type": "groupBy",
            "typeID": 0,
            "groupType": "entity",
            "groupID": 1,
            "groupAttribute": "name",
            "byType": "entity",
            "byID": 0,
            "byAttribute": "age",
            "appliedModifier": "AVG",
            "constraints": [
                {
                    "attribute": "age",
                    "value": "45",
                    "dataType": "number",
                    "matchType": "GT",
                    "functionPointer": {
                        "from": -1,
                        "to": -1
                    }
           
                }
            ]
        }
    ],
    "limit": 5000,
    "modifiers": [],
    "databaseName": "TweedeKamer"
}
`)

	var inc entity.IncomingQueryJSON
	json.Unmarshal(js, &inc)
	result, _ := queryservice.ConvertQuery(&inc)
	log.Println(*result)
}
